
function order.set_ship_name(ship,name)
  ship.name=name
end

_G.get_class_refit_info = weak_memoizeNN | function(source_ship)
  local source_design in source_ship
  local push, rval = pusher {}
  local refitable = 0

  local function check_ship(star, ship, fleet, planet)

    if (source_ship.drawer==ship.drawer) and table_eq(source_design,ship.source_design)
      local cant_instant_refit in ship
      if not cant_instant_refit
        refitable++
      end
      push {
        ..ship,
        ..star,
        ..fleet,
        ..cant_instant_refit,
        ..planet,
      }
    end

  end

  for _ , fleet  ; source_ship.empire.fleets
    local star = at_star(fleet)
    for ship ; fleet.ships
      check_ship(star,ship,fleet,nil)
    end
  end

  for planet  ; source_ship.empire.planets
    local star = planet.star
    for slot,orbital in planet:orbital_list()
      check_ship(star,orbital,nil,planet)
    end
  end

  return rval,refitable
end

local function refit_ship_to_option(ship,option)
	ship=ship.carried_ship or ship
  local design,coin_cost,metal_cost in option!
  local fuel_depot in ship 
  local rename = ship.name == ship.source_design.design_name
  --print(..rename,..ship.name,..ship.source_design.design_name)
  local old_name= ship.name

  ship:refit_to_design(design)
  if rename
    ship.name=design.design_name
  else
    ship.name=old_name
  end


  local empire in ship
  empire.credits-=coin_cost
  empire.metal-=metal_cost

  if empire == gui_player()
    mark_achievement 'ACH_REFIT_SHIP'
  end

	--[[

	-- under the latest outpost rule revisions, this is no longer
	-- an issue
  if fuel_depot and not ship.fuel_depot
    --error 'interesting case!'
  
    -- duh dun!, someone has quite possibly just broken their
    -- outpost!
    local planet,orbit_i = ship2planet(ship)
    order.  check_for_lost_outpost(planet)
  end
	--]]

  ship.last_instant_refit = galaxy.year

  local fleet = find_ships_fleet(ship)
  if fleet
    order.cancel_inactive_ship_motion_orders(fleet)
    if fleet._ikey==gui.GalaxyMap.selected_map_key
     -- print('reseting!!')
      gui.GalaxyMap.reset_motion_selections()
    end  
  end
end

insert(_G,..refit_ship_to_option)

_G.get_design_refit_info = weak_memoizeNN | function(source_design,empire)

  local push, candidates = pusher {}

  local out_of_date=true

  for design_key,design in rpairs | empire.designs

    if (design.config_table==source_design.config_table)
      local hammer_cost,metal_cost = source_design.refit_cost( design)
      local ident = (hammer_cost + metal_cost) == 0

      push {
        ..design,
        ..hammer_cost,
        ..metal_cost,
        coin_cost=empire.coins_to_labor_rate*hammer_cost,
        ..ident,
      }

      if ident
        out_of_date=nil
      end
    end

  end

  table.sort(candidates,|) function(c1,c2)
    return lexical_compare(
      c1.hammer_cost,c2.hammer_cost,
      c1.design,c2.design
    )
  end

  insert(candidates,..out_of_date)

  return candidates
end

_G.get_ship_refit_info = function(ship)
  return get_design_refit_info( ship.source_design,ship.empire)
end


UI_File | function(_ENV)

_ENV = ensure_property_env(_ENV,'ship_status_pane')

SystemsPane(_ENV)

function Property.ship_drawer ()
  return object and object.drawer
end

function Property.drawer_t ()
  if not object return end

  local drawer = object.drawer

  if drawer
    return drawers[drawer]
  end
end

function on_zero_alpha()
  object=nil
end

function allow_leftside_report()
  return not tight_layout
end

StatusSkin0(_ENV,skin_options)

local systems_zoom = midpane_zoom_handler(ship_status_pane)
local desc_zoom = midpane_zoom_handler(ship_status_pane)
local subbox

add_resize_callback | function()

  subbox = skin.ship_systems()!.subbox

  text_context = new_text_rendering_context {
    name = 'ship_midscreen_pane',
  }

  --ship_profile_rect
  local sx,sy,sw,sh

  local x,y,w,h = midscreen_rect_plus()
  h-=70
  y+=10
  x+=2
  w-=4

  complete_rect=catch(x,y,w,h)


  local layout_w in layout!

  sh=h
  sy=y
  sx=x

  local system_w=400+20
  local mid_w = 498-20

  half_complete_rect = catch(x,y,w-system_w,h)

  sw=w-system_w-mid_w

  -- in the default planet panes, the planet box area is 678
  -- wide.
  --print( sw - 678)


  ship_profile_rect = catch(sx,sy,sw,sh)
  ship_clip_rect =catch | box_grow(-18,-20,sx+5,sy-10,sw+1,sh+24)
  profile_inset_rect = catch | box_grow(-18,-44,sx+5,sy-14,sw+1,sh)
  title_pick = catch | box_grow(-40,0,sx,sy+sh-60,sw,50)


  profile_close_element = function()
    local x,y,w,h=ship_profile_rect()
    return Small_X.close_element(profile_close_element,x+w-36+9,y+h-19)
  end

  rightside_close_element = function()
    return Small_X.close_element(rightside_close_element,x+w-36+9,y+h-17)
  end



  --!! system drawers
  do
    local mx,my,mw,mh = layout_w-system_w, sy, system_w, sh
    mw-=8
    system_list_rect = catch(mx,my,mw,mh)

    local function make_systems_rect(x,y,w,h)
      local rval = old_style_part_list_frame(x,y,w,h,|) {
			  ysep=12, bh=78, 
			  yfix = -9,
			  countfun = function() return count_parts() end,
        push_zoom_handler = systems_zoom,
        --Frame = SolidLongFrame,
        Frame = SimpleLongFrame,

        bk_rect=catch | box_grow(-12,0,x+10,y,w,h),

        draw_bk = restore_color | function ()
          set_frame_color4 | drawers.frame_colors.light_bk_color()
          glBox | box_grow(-12,-10,x-3,y,w,h)
        end,
		  }

      rval.title=_SAFE

      --[[
      rval.title = restore_color | function ()
        set_frame_color4 | white()
        text_context.lazy_word_render('vera_bold17','Systems').draw_hcentered(x+w*.5,y+h-22)
	    end
      --]]
      return rval
    end


    local trade_h=160

    ship_systems_frame = make_systems_rect(mx,my,mw,mh-trade_h-10)
    trade_pane_rect = catch(mx,my+mh-trade_h,mw,trade_h)
  end

  --!! add trade option
  local function add_trade_option(vboxes)

    local ship=object
    local civilians,trade_eta in ship
    local fleet = find_ships_fleet(ship)




    vboxes.add_gradient_button {

      text = shorthand_format ('Start Trading'),
      gradient_color = 'yellow',  
      icon = 'spaceship',   

      ..text_context,

      force_rw=280,
      force_rx=60,


      invalid = function() 
        return ship.inactive or ship.carrying_pop or ship.transport_dest or  ( type(trade_eta)=='number' )
      end,

      tooltip_text = shorthand_format | 'Send this ship to the trade pool.  It will instantly be removed from the strategic map.',
      on_click = function()
        end_star_selection?()
        fallback_click_sound 'FLEET_MOVE_CONFIRMED'
        order.assign_ship_to_trade(ship,fleet,true)
      end,
    }
    vboxes.add_vspace(5)
    
    if ship.transport_dest

      vboxes.add_text_vbox | desc_format | format([=[
        This ship is under civilian command.  It's currently transporting
        colonists to %s, and will return to trading duties once it arrives.
        ]=],ship.transport_dest.name)

    elseif type(trade_eta)=='number'
      if trade_eta==0
      
        vboxes.add_text_vbox | desc_format | format([=[
        This ship has joined the trade pool; it contributes <b>%d</b><CARGO>
        per turn towards our empire's <bi>cargo capacity</bi>.  
        ]=],ship!.trade_capacity,) 
      else
        vboxes.add_text_vbox | desc_format | format( [=[
        This ship has joined the trade pool; it contributes <b>%d</b><CARGO>
        per turn towards our empire's <bi>cargo capacity</bi>.  
        
        <br> <br> 
        After <b>%d turns</b>, it will also be available for colonist
        population transport.
        ]=], ship!.trade_capacity, trade_eta) 
      end

    elseif ship.carrying_pop
      vboxes.add_text_vbox | desc_format [=[
        Colonists must disembark before the ship can be assigned to trade
        duties.
      ]=]
    else
     
      vboxes.add_text_vbox | desc_format | format([=[
        Transfer this ship to the trade pool, removing it from the strategic
        map, and adding <b>%d</b><CARGO> to our empire's <bi>cargo
        capacity</bi>. <CARGO> is essential for transporting <FOOD> between
        our colonies. Excess cargo beyond that required for <FOOD> can
        generate <COIN> through trade.  
      ]=], ship!.trade_capacity)
     
     end
   
   end




  local colony_h = 240



  expanded_desc_rect = catch | box_grow(-12,0, sx+sw,sy,mid_w,sh-colony_h-10)
  biggest_desc_rect = catch | box_grow(-12,0, sx+sw,sy,mid_w,sh)
  colony_pane_rect=catch | box_grow(-12,0,  sx+sw,sy+sh-colony_h,mid_w,colony_h)

  --!! colony pane
  do
    draw_colony_pane=nil
    function rebuild_draw_colony_pane()
      
      local x,y,w,h=colony_pane_rect()

      --

      local improvement_h=32
      local improvement_pt=18
      local improvement_list_rect = catch | box_grow(-30,0,x,y-12-improvement_h+h,w,improvement_pt)
      

      local colonize_tooltip_el = new_tip_maker { 
        delayed_draw_context = dropdown_menu!,
        style = 'draw_center_left', 
        dx=-200,dy=30,text_width=180,no_desc_text=true }
      local planet in SCOPE!

      local colonize_info_element
      if not gui_player():can_colonize(planet)
        colonize_info_element=colonize_tooltip_el | format(
           "We can't colonize <bi>%s</bi> planets without first researching additional <bi>Planetology</bi> technologies.",
           planet.type)
      else
         colonize_info_element=colonize_tooltip_el | format(
           "To found a colony on %s, move a colony ship to the %s system, then select the <bi>Colonize</bi> planet action.",
            planet.name,planet.star.name)
      end

      draw_colony_pane = SCOPE_fun(bk_color_key='nav_bk_color',|) function()
        local planet in SCOPE!

        ShortNavTitleFrame.draw_bk | colony_pane_rect()


        draw_improvement_icons(planet,improvement_list_rect())

        if not planet.has_pop 
          local word = text_context.lazy_word_render('orig40',
            gui_player():can_colonize(planet) and 'NOT COLONIZED' or 'CANNOT BE COLONIZED')

          colonize_info_element |           call_with_frame_color(grey,word.draw_hcentered,x+w*.5,y+h*.39)

        else
          local bx,by,bw,bh = box_grow(-15,0,x,y+3,w,h-58)
          draw_planet_pop(0,planet,bx,by,bw,bh,_SAFE,false,true)
        end


        ShortNavTitleFrame.draw_frame | colony_pane_rect()

        --glBox | improvement_list_rect()

      end


    end

  end


  --!! stats drawers 
  do
    stats_rect=trade_pane_rect

    local x,y,w,h=box_grow(-10,-10,|) stats_rect()
    w-=5

    --[[y-=10
    x+=10
    h-=20
    --]]

    draw_status_pane=nil

    local min_em_height = 3
    local min_em_width = 19 --25
    local max_em = 28
    local em = floor | min( h/min_em_height, w/min_em_width, max_em )

    --print(..em,h/min_em_height,w/min_em_width)


    local min_pt = 10
    local pt = max(min_pt, em)


    local stats_cache = make_hover_text_cache {
      name = 'ship_pane_stats',
      text_width = w,
      default_font_key=format('vera%d',pt),
    }


    local itemstring(v)
      if (v or 0) >= max_double
        return 'Inf '
      end
      return tostring(v)
    end



    local function render(...)
      return stats_cache.lazy_gen | shorthand_format | format(...)
    end 


    local x0 = x+pt*.8
    local x1 = x+w-pt*9
    local y0 = y+h-pt*2
    local y3 = y+pt*1
    local y1 = (1/3)* ( y3-y0 ) + y0
    local y2 = (2/3)* ( y3-y0 ) + y0



    local stat_color = {
      shields = '1a94ff',
      armor = 'ffa20d',
      --hull = 'ff520e',
      crew = '5cd400',
      munitions='ff4603',
      upkeep = 'ffff00',
      neg_power = 'ff0000',
      --power='5cd400',
      --speed = 'ffffff',

    } 


    local function stat_box(v,x,y,stat,icon,name,align)
      name = name or tostring(capitalize(stat))
      local item
      local color = stat_color[stat]
      if color
        item = color_desc_text(color, itemstring( v ) ) 
      else
        item = itemstring(v)
      end

      item ..= icon or format('<%s>', stat:upper() )

      local text = name.. ': ' .. (align or '')  .. item
      local word = render | text


      local el = element | box_grow(2,2,word.draw_bl(x,y))

      el.desc_text=name

      --glBox | centered_box (x,y,100,100)

    end



    local align1 = add_align(3.6)

    function rebuild_status_pane()


      draw_status_pane = SCOPE_fun(bk_color_key='nav_bk_color',|) function()

        ShortNavFrame.draw_bk | stats_rect()

        local speed = object.empire : speed_from_class(object.speed_class)

        stat_box(object.structure-(object.structure_damage or 0), x0,y0,'hull')
        stat_box(object.armor-(object.armor_damage or 0), x1,y0,'armor',nil,nil,add_align(4.2))

        stat_box(speed, x0,y1,'speed','<SPEED>')
        stat_box(object.max_shields or 0, x1,y1,'shields','<SHIELD>',nil,add_align(4.2))

        stat_box( object.crew_from_embarked + object.max_crew - (object.crew_damage or 0), x0,y2,'crew','<MARINES>')
        stat_box(object.coin_upkeep, x1,y2,'upkeep','<COIN>',nil,add_align(4.2))

        local munition_shift_em=1.15
        stat_box(object.munitions or 0, x1-em*munition_shift_em,y3,'munitions','<AMMO>',nil,add_align(4.2+munition_shift_em))
--        stat_box(object.upkeep, x1,y3,'upkeep','<COIN>')


        --if object.munitions
        --  stat_box(object.munitions, x2,y1,'munitions','<AMMO>')
        --end

      
        --glBox(x,y,w,h)

        ShortNavFrame.draw_frame | stats_rect()
        --local x,y,w,h=stats_rect()
        --text_context.lazy_word_render('vera_bold17','Status').draw_hcentered(x+w*.5,y+h-22)
      
        
      
      end

    end


  end

  
  draw_desc_pane = nil

  --!! desc pane
  local desc_text_context = new_text_rendering_context {
    name = 'Ship Status DescPane Text',
--    default_font_key = 'vera15',
--    default_title_key = 'orig_cond26',

    default_font_key = 'vera14', 
    default_title_key = 'orig_cond24',


    link_color = {1,1,1},
  }

  local desc_scroll_area, current_desc_rect

  desc_zoom | function(dz)
    if draw_desc_pane
      return desc_scroll_area.handle_zoom_in_rect(dz,current_desc_rect())
    end
  end

  local function make_chibi_passenger_drawfun(cx,cy,key)
    local shadow_options = {sigma=.8,spread=.5,opacity=.9}
		key = key or 'carrying_pop'
    return function()
      local ship = object
 
      local i=1
      local offsets = pop_art_chibi_offsets[nkeys(ship[key])]
      for race,n in spairs | ship[key] 
        local offset = offsets[ 1 + (i-1) % #pop_art_chibi_offsets ]
        local dx,dy=unpack(offset)
        dx,dy*=1.4
        FLAG_call('chibi_passenger',
          SCOPE_call, icon_empire=ship.empire,
        drawers.PopIcons.chibi_draw,race,dx+cx,dy+cy)
        i++
      end
      local word = text_context.lazy_word_render('vera14',tostring | round | sum(ship[key]))
      
      if not word.draw_shadow
        shadowed_word(shadow_options,word)
      end
      local x=cx-word.w*.5+1
      local y=cy
      word.draw_shadow(x,y)
      word.draw(x,y)

    end
  end

  local function add_alien_transport_info(vboxes)
    local ship=object


    vboxes.add_vspace()

    local add_alt_text = vboxes.new_vbox_text_for_options {
        font_key='vera14',
        w=  ( sum(ship.carrying_pop?) >0 ) and 340,
      }

      add_alt_text | desc_format | format( [[
          <b>Carrying Population</b>: This ship has cargo space that can be used to
          transport %d unit%s of population, or ground based military units.
       ]], object.pop_space, object.pop_space==1 and '' or 's')

    if sum(ship.carrying_pop?) > 0

      --local word = vboxes.text_context.lazy_word_render('vera_bold14','Carrying:')
      local drawchibi=make_chibi_passenger_drawfun(370,-4)
      local function draw()
      --  word.draw(10,30)
        drawchibi()
  --      glBox(0,0,100,60)
      end
      vboxes.add_vbox(draw,0)

    end


  end


  --!! massrefit opbutton
  local function add_mass_refit_button(vboxes)

    -- don't show the button if we're not in a possition where a
    -- normal refit would be possible.
    local cant_instant_refit in object
    if cant_instant_refit
      return
    end
 
    local source_design in object
    local mass_ships,refitable = get_class_refit_info(object)
    local options = get_ship_refit_info(object)

    if #options<=1
      if #options==0 return end
      -- the no-dropdown case
      local coin_cost, metal_cost in options[1]
      -- if are one possible refit option is always going to be
      -- invalid, don't add a mass refit.
      if options[1].ident
        return
      end
      if (coin_cost>object.empire.credits) return end
      if (metal_cost>object.empire.metal) return end
    end


    local function do_mass_refit()
      local option = get_current_refit_option()
      execute_order('mass_refit',|) function()
        for i,info in ipairs | mass_ships
          local ship,cant_instant_refit in info
          if not cant_instant_refit
            refit_ship_to_option(ship,option)
          end

        end
      end
    end
    vboxes.add_vspace(28)

    vboxes.add_gradient_button {

      text = 'Mass Refit',
      gradient_color = 'orange',  
      icon = 'fleet',   
      valid_cursor = red_cursor,
      ..text_context,

--      rx=60,
--      ry=0,
--      rw=98,

      force_rw=280,
      force_rx=60,

      invalid = function() 
        local option = get_current_refit_option?()
        if #mass_ships==1 return true end
        if not option
          return true
        end
        if option.ident
          return true
        end
        local cant_instant_refit in object
        if cant_instant_refit
          return true
        end

        local coin_cost,metal_cost in option
        coin_cost,metal_cost*=refitable
        local credits,metal in object.empire
        return (coin_cost>credits) or (metal_cost>metal)
      end,

      tooltip_text = SCOPE_fun(..context_subs,|) function() 

        local coin_cost,metal_cost in get_current_refit_option?()?

        if not coin_cost
          return shorthand_format 'This <SHIP_STATION> cannot be refitted.'
        end

        coin_cost,metal_cost*=refitable
        local credits,metal in object.empire
        if (coin_cost>credits) or (metal_cost>metal)
          return shorthand_format "We don't have enough resources to perform this <bi>Mass Refit</bi> action."
        end

        return shorthand_format 'Refit all <SHIPS_STATIONS> of this design to a new specification.'
      end,

      on_click = function()
        Sounds.SELECT_FOR_PRODUCTION()
        do_mass_refit()
      end,

    } 

    vboxes.add_vspace | 5

    if #mass_ships==1     
      return vboxes.add_text_vbox | desc_format | format [[
        This is our only current example of this
        <bi><OBJECT_DESIGN_NAME></bi> design, so it cannot be used as the
        basis for a <bi>Mass Refit</bi> action.
      ]]
    end

    if refitable==1     
      return vboxes.add_text_vbox | desc_format | format [[
        
        While there are other ships in our fleet outfitted as per this
        <bi><OBJECT_DESIGN_NAME></bi> design, none of them are stationed in
        systems with sufficient infrastructure to perform a refit. Thus, we
        are unable to perform a <bi>Mass Refit</bi>.
        
        ]] 
        end

    local function mass_refit_text()
      local coin_cost, metal_cost,ident in get_current_refit_option()


      if ident
        return desc_format | format [[
          We can't perform a mass refit unless a valid refit option is selected.
        ]]
      end

      coin_cost*=refitable
      metal_cost*=refitable

      if #mass_ships~=refitable

        local rval = format ([[ For a one-time cost of %d<COIN> and %d<METAL>, upgrade the %d <SHIPS_STATIONS> in our fleet outfitted like this one to the current
          <bi><REFIT_DESIGN_NAME></bi> design. ]],
          coin_cost, metal_cost, refitable)

        local missed = #mass_ships - refitable

        rval ..= format( [[
          Note that there %s of this design that cannot be refitted, because %s not
          currently stationed in systems with sufficient infrastructure to
          perform the refit.]],

          (missed==1) and "is 1 ship" or format("are %d <SHIPS_STATIONS>",missed),
          (missed==1) and "it is" or "they are",
        )

        return desc_format | rval
      else
        return desc_format | format ([[ 
          For a one-time cost of %d<COIN> and %d<METAL>, upgrade all %d
          <SHIPS_STATIONS> in our fleet using this
          <bi><OBJECT_DESIGN_NAME></bi> design to the current
          <bi><REFIT_DESIGN_NAME></bi> design. 
        ]], coin_cost, metal_cost, #mass_ships)
      end
    end

    vboxes.add_dynamic_text_box | function()
      return 'vera14', mass_refit_text()
    end

  end

  local function add_inactive_info(vboxes)

    local word = vboxes.text_context.lazy_word_render('xolonium21','Inactive')

    local function draw()
      local icon_radius_hint=30
      SCOPE_call(..icon_radius_hint,
        notification_icons.misc.sleep.simple_draw,40,30)
      word.draw(76,25)
    end

    vboxes.add_vbox(draw,40)

    if object.inactive=='refitting'
      vboxes.add_text_vbox | desc_format [=[
        This unit is undergoing refit and is inactive. It will be
        unable to move or fire its weapons until this process
        is complete.
      ]=]
    end


  end

  --!! add refit options
  local function add_refit_option(vboxes)
    local text_context in vboxes!


    vboxes.add_gradient_button {

      text = 'Refit' ,
      gradient_color = 'orange',  
      icon = 'labor',   
      valid_cursor = red_cursor,
      ..text_context,

--      rx=60,
--      ry=0,
--      rw=98,

      force_rw=280,
      force_rx=60,

      invalid = function() 
        local option = get_current_refit_option?()
        if not option
          return true
        end
        if option.ident
          return true
        end
        local cant_instant_refit in object
        if cant_instant_refit
          return true
        end

        local credits, metal in gui_player()!
        local coin_cost, metal_cost in option!

        return (coin_cost>credits) or (metal_cost>metal)
      end,

      tooltip_text = SCOPE_fun(..context_subs,|) function() 
				local cant_instant_refit in (object.carrying_ship or object)
        if cant_instant_refit=='outpost_transport_cant_refit'
					return "Can't refit loaded transports."
				elseif cant_instant_refit
          return 'No shipyards available.'
        end
        local option = get_current_refit_option?()
        if not option
          return shorthand_format  'We currently have no designs compatible with this <SHIP_STATION> hull.'
        end
        if option?.ident
          return shorthand_format 'This <SHIP_STATION> is already up to date with our latest <bi><REFIT_DESIGN_NAME></bi> design.'
        end
        return shorthand_format 'Refit instantly to the current <bi><REFIT_DESIGN_NAME></bi> design for <REFIT_COST>.'
      end,
      on_click = function()
        Sounds.SELECT_FOR_PRODUCTION()
        do_refit()

        --order.sacrifice_slave(planet,race,'beakers')
        --on_race_status_change()
      end,

    }

    vboxes.add_vspace | 5



    local cant_instant_refit in (object.carrying_ship or object)

    if cant_instant_refit=='construction_tier'
      local star = at_star | find_ships_fleet | object
      local required_tier in object.config_table
      vboxes.add_text_vbox | desc_format| format( [[ 
        None of our colonies in the %s system have sufficient orbital
        construction facilities to refit this vessel.  Refitting
        a <bi><SHIP_CONFIG_NAME></bi> hull requires a planet with at least %d
        <bi>Construction Module%s</bi>.
      ]] , star.name, required_tier, required_tier==1 and '' or 's')
      return
    elseif cant_instant_refit=='hull_locked'
 
       vboxes.add_text_vbox | desc_format [[ 
        This vessels is constructed using alien technologies; our engineers
        are unable to refit it. 
      ]] 
      return
    elseif cant_instant_refit=='refitting_at_planet'

       vboxes.add_text_vbox | desc_format | format([[ 
        This <SHIP_STATION> is already undergoing a refit at <bi>%s</bi>.
      ]],object.refitting_at.name) 
      return

    elseif cant_instant_refit=='outpost_transport_cant_refit'
        vboxes.add_text_vbox | desc_format [[ 
          Loaded outpost transports cannot be refitted. 
				]] 
				return
				
		elseif cant_instant_refit=='no_colony' 
		
		if object.orbiting_planet

        vboxes.add_text_vbox | desc_format [[ 
          Refitting stations is only possible when we have a colony on the planet
          they're orbiting. 
        ]] 
      else
        vboxes.add_text_vbox | desc_format [[ 
          Refitting <SHIPS_STATIONS> is only possible when we have a colony in
          the system. 
        ]] 
      end
      return
    end

    if cant_instant_refit
      vboxes.add_text_vbox | desc_format [[ 
        Refitting <SHIPS_STATIONS> is only possible when they are stationed
        in the same system as one of our bases.
        ]]
      return
    end

    local dropdown_h=30

    local options = get_ship_refit_info(object)
    local current_refit_option=1

    function get_current_refit_option()
      return options[current_refit_option]
    end

    if not options[1]
      vboxes.add_text_vbox | desc_format [[ 
        We currently have no designs compatible with this <SHIP_STATION>
        hull.
        ]]
      return
    end

    function do_refit()
      local option = get_current_refit_option()
      local coin_cost,metal_cost in option!
      if (metal_cost+coin_cost) > 0
        execute_order('instant_refit',|) function()
          refit_ship_to_option(object,option)
        end
        name_edit.set_text(object.name)
      end
    end

    if #options > 1

      local rx=90
      local rw=248
      local ry=0
      local rh=dropdown_h

      local dropdown_options = {
        ypad=5, 
        make_word = function(str)
          return text_context.lazy_word_render('vera15',str)
        end,   
        left_justify=18,

        on_select = function(_,_,i)
          current_refit_option=i
          --set_base_ship_desc_text()
        end,

      }
      for i, option in ipairs | options
        dropdown_options[i]=option.design.design_name
      end

      local dropdown_id = options

      local refit_dropdown = function()
        --grad_button_rounded_rect(rx,ry,rw,rh)
        --glBox(rx,ry,rw,rh)

        dropdown_menu.draw_bk(rx,  ry, rw, rh)

        local word = text_context.lazy_word_render('vera14',shorthand_format 'To design:')
        word.draw(10,8)

        local word = text_context.lazy_word_render('vera17',shorthand_format '<REFIT_DESIGN_NAME>')
        word.draw(rx+8,8)

        vertical_arrows.draw_small_down( rx + rw-18, 12+ry )

--        draw_rimage(embark_pane.wedge_img,rx+rw-40,16)

        local el = element(rx,ry,rw,rh)

        el.dropdown_id=dropdown_id
        el.on_click = dropdown_menu.on_open_dropdown
        dropdown_menu.register_menu(dropdown_id, dropdown_options,rx,ry,rw,rh)

      end

      vboxes.add_vspace | 3
      vboxes.add_vbox(refit_dropdown,dropdown_h)
      vboxes.add_vspace | 4

    else
--      vboxes.add_vspace | -1
    end

    local function refit_text()
    
     local option = get_current_refit_option()
     if option?.ident
      return shorthand_format 'This <SHIP_STATION> is already outfitted as per the current <bi><REFIT_DESIGN_NAME></bi> design.'
     end


     return desc_format [[          
        Refit this <SHIP_STATION> to the current
        <bi><REFIT_DESIGN_NAME></bi> design for a one-time cost of
        <REFIT_COST>.
      ]]

    end

    vboxes.add_dynamic_text_box | function()
      return 'vera14', refit_text()
    end

    add_mass_refit_button(vboxes)

    --[[

    vboxes.add_vspace | 2

    local mass_toggle_h=28
    local refit_word = text_context.lazy_word_render('vera_bold16','Mass Refit')
    local function toggle_mass_refit()
      mass_refit_toggle = not mass_refit_toggle
    end
    local function draw_mass_toggle()

      radio_button.draw(
        mass_refit_toggle and 1 or 0,
        43,
        9,
        12.5 )

      local el = element | centered_box(43,9,280,20)
      el.on_click = toggle_mass_refit
      el.sound =  mass_refit_toggle and 'MOUSE_CLICK' or 'DIALOG_OK'

      local option = get_current_refit_option()
      if option.ident
        call_with_frame_color(grey,refit_word.draw,63,3)
      else
        refit_word.draw(63,3)
      end

    end
    vboxes.add_vbox(draw_mass_toggle,mass_toggle_h)

    --]]

  end

	--!! enter/leave orbit options
	local function add_enter_orbit_option(vboxes)
		local ship=object

		local invalid = ship:cant_enter_orbit()

		local tooltip_text = 'Enter the orbit of a planet in this system.'
		 
		 if invalid=='no_space'
		    tooltip_text='There are no suitable planets in range.'
		 elseif invalid=='under_attack'
				tooltip_text="Can't enter orbit while under attack!"
		 elseif invalid=='in_transit'
				tooltip_text="Ship is in hyperspace."
		 end

    vboxes.add_gradient_button {        
      text = shorthand_format ('Enter Orbit'),
      gradient_color = 'pale_green',  
      icon = 'enter_orbit',   
      valid_cursor = red_cursor,

      force_rw=280,
      force_rx=60,

      invalid = function() 
        return invalid
				--return embark_invalid
      end,

      ..tooltip_text,
			on_click = function(el)
        --order.sacrifice_slave(planet,race,'beakers')
        --on_race_status_change()
        --embark_click(el)
				local ship in el!
				--local planet = star:has_space_for_station(ship)
				enter_orbit_click(el)
				--Sounds.INSERT_STATION_ORBIT()
      end,
      element_pairs = catch(..ship),
    }

    vboxes.add_vspace(5)
    vboxes.add_text_vbox | desc_format [[
        Order this mobile station to enter an available planetary orbital
        slot, and establish or join any existing outpost or colony there. 
		]] 

	end

	local function add_leave_orbit_option(vboxes)
		local ship=object
		local invalid = ship:cant_leave_orbit()
		local tooltip_text = 'Leave orbit and join the system fleet.'

		if invalid=='under_attack'
			tooltip_text="Can't leave orbit while under attack!"
		end

    vboxes.add_gradient_button {        
      text = shorthand_format ('Leave Orbit'),
      gradient_color = 'pale_green',  
      icon = 'leave_orbit',   
      valid_cursor = red_cursor,

      force_rw=280,
      force_rx=60,

      invalid = function() 
        return invalid
				--return embark_invalid
      end,

      ..tooltip_text,
      on_click = function(el)
        --order.sacrifice_slave(planet,race,'beakers')
        --on_race_status_change()
        --embark_click(el)
				order.leave_orbit(el.ship)
				for id,fleet ; gui_player().fleets
					if fleet.ships[el.ship]
						select_map_key(id)
					end
				end
				Sounds.REMOVE_STATION_ORBIT()
      end,
      element_pairs = catch(..ship),
    }

    vboxes.add_vspace(5)
    vboxes.add_text_vbox | desc_format [[
        Order this mobile station to leave orbit and join the system fleet.
				Any colony effects provided by this station will be canceled.
				]] 

	end


	--!! load/unload hab options

	local function add_hab_pop_options(vboxes)
		local ship = object
		local summed_hab_pop, empty_hab_space,cant_load_hab,cant_unload_hab in ship
		
    local draw_only_load=cant_unload_hab and (cant_unload_hab~='already_unloaded') and (not cant_load_hab)

    local function add_hab_colonist_info()
      local cx,cy=110,10
      vboxes.add_vspace(5)

      local text = format( [[
          This ship has orbital habitats that are able to support %d unit%s
					of population.  Population in orbital habitats will contribute to the
					production of any planet they orbit.
					]], object.hab_space, object.hab_space==1 and '' or
          's')

					--[==[
      if next(ship.hab_pop?)
        text ..= format( [[ 
          <br><br> ]]) 
       end
			 --]==]

      vboxes.add_text_vbox | desc_format | text
    end

		if draw_only_load or (not cant_load_hab)
			vboxes.add_gradient_button {        
					text = shorthand_format ('Load  Habitat'),
					gradient_color = 'blue',  
					icon = 'embark',   
					valid_cursor = red_cursor,

					force_rw=280,
					force_rx=60,

					invalid = function() 
						return cant_load_hab
					end,

					tooltip_text = 'Load the habitat module using colonists from a planet in this system.',
					on_click = function(el)
						--order.sacrifice_slave(planet,race,'beakers')
						--on_race_status_change()
						load_hab_click(el)
					end,
					element_pairs = catch(ship=ship.carrying_ship or ship),
				}
				add_hab_colonist_info()
		end

    if not draw_only_load
		  if not cant_load_hab
        vboxes.add_vspace()
      end

      vboxes.add_gradient_button {        
        text = 'Unload Habitat',
        gradient_color = 'blue',  
        icon = 'disembark',   
        valid_cursor = red_cursor,

        force_rw=280,
        force_rx=60,

        invalid = function() 
          return cant_unload_hab
        end,

        tooltip_text = SCOPE_fun(..context_subs,|) function()
          --if disembark_invalid
          --end

          if cant_unload_hab=='already_unloaded'
            return shorthand_format 'This vessel has already unloaded colonists once this turn, and must wait until the next turn before performing an additional unloaded action.'
          end

          return 'Unload to a planet in this system.',
        end,

        on_click = function(el)
          
          --order.sacrifice_slave(planet,race,'beakers')
          --on_race_status_change()
          unload_hab_click(el)
        end,

        element_pairs = catch(ship=ship.carrying_ship or ship),
      }

      if next | ship.hab_pop?
        local draw = make_chibi_passenger_drawfun(380,-4,'hab_pop')
        vboxes.add_vbox(draw,0)
      end

      add_hab_colonist_info()

		end


	end


  --!! embark/disembark options
  local function add_population_transport_options(vboxes)
    local ship=object
    local disembark_invalid,embark_invalid,crew_from_embarked in ship



    local function add_carrying_colonists_info()
      local cx,cy=110,10
      vboxes.add_vspace(5)

      local text = format( [[
          This ship has cargo space that can be used to transport %d unit%s of
          population.
        ]], object.pop_space, object.pop_space==1 and '' or 's')

      if next(ship.carrying_pop?)
        text ..= format( [[ 
          <br><br>Embarked units are able to lend support during boarding
          actions; the ship's current passengers increase its crew rating by
          <b>+%d</b><MARINES>.
        ]],   crew_from_embarked)
          
        end

      vboxes.add_text_vbox | desc_format | text
    end

    local draw_only_embark= disembark_invalid and (disembark_invalid~='already_disembarked') and (not embark_invalid)
    if draw_only_embark or (not embark_invalid)

      vboxes.add_gradient_button {        
        text = shorthand_format ('Embark Colonists'),
        gradient_color = 'purple',  
        icon = 'embark',   
        valid_cursor = red_cursor,

        force_rw=280,
        force_rx=60,

        invalid = function() 
          return embark_invalid
        end,

        tooltip_text = 'Embark colonists from a planet in this system.',
        on_click = function(el)
          --order.sacrifice_slave(planet,race,'beakers')
          --on_race_status_change()
          embark_click(el)
        end,
        element_pairs = catch(..ship),
      }

      add_carrying_colonists_info()
    end


    if (not draw_only_embark) 

      if not embark_invalid
        vboxes.add_vspace()
      end

      local popname='Colonists'
      if ship.carrying_pop?.tanks
        popname='Brigade'
        if sum(ship.carrying_pop) > 1
          popname='Brigades'
        end
      end

      vboxes.add_gradient_button {        
        text = 'Disembark '..popname,
        gradient_color = 'purple',  
        icon = 'disembark',   
        valid_cursor = red_cursor,

        force_rw=280,
        force_rx=60,

        invalid = function() 
          return disembark_invalid
        end,

        tooltip_text = SCOPE_fun(..context_subs,|) function()
          --if disembark_invalid
          --end

          if disembark_invalid=='already_disembarked'
            return shorthand_format 'This vessel has already disembarked colonists once this turn, and must wait until the next turn before performing an additional disembark action.'
          end

          return 'Disembark to a planet in this system.',
        end,

        on_click = function(el)
          
          --order.sacrifice_slave(planet,race,'beakers')
          --on_race_status_change()
          disembark_click(el)
        end,

        element_pairs = catch(..ship),
      }


      if next | ship.carrying_pop?
        local draw = make_chibi_passenger_drawfun(380,-4)
        vboxes.add_vbox(draw,0)
      end

      add_carrying_colonists_info()

            --[=[

      vboxes.add_vspace(5)
      vboxes.add_text_vbox | desc_format | format( [[
          <OBJECT_NAME> has cargo space that can be used to transport %d unit%s of
          population.
       ]], object.pop_space, object.pop_space==1 and '' or 's')

       --]=]


    end

  end

  --!! colonize option
  local function add_colonize_option(vboxes)
    local fleet = find_ships_fleet | object
    local star =at_star ( fleet! )

    local r = star and light_report_search(fleet.empire,type='colonize',..star)


    SCOPE_call(report=r,|) function()
      vboxes.add_gradient_button {        
        text = shorthand_format ('Colonize Planet'),
        gradient_color = 'green',  
        icon = 'flag',   
        valid_cursor = red_cursor,

        force_rw=280,
        force_rx=60,

        invalid = function() 
          return not r
        end,

        tooltip_text = SCOPE_fun(report=r, ..context_subs,|) function()
          return 'Show colonizable planets.'
        end,
        on_click = function()
          --order.sacrifice_slave(planet,race,'beakers')
          --on_race_status_change()
          select_map_key(r)
        end,
      }
      vboxes.add_vspace(5)
      if star
        if r
          vboxes.add_text_vbox | desc_format [[
              Found a colony on a world in the <bi><STAR_NAME></bi> system.
           ]]
        else
          vboxes.add_text_vbox | desc_format [[
            There are no colonizable worlds in this system.
         ]]

        end
      else
         vboxes.add_text_vbox | desc_format [[
           This ship is currently traveling between star systems, and so is unable
           to found colonies.
        ]]      
      end
   end

  end

  --!! Deploy fighter option
  local function add_fighter_role_option(vboxes)
    local ship = object
	local empire in ship
	local i=0

	for w in weapons(ship)
	  if w.is_fighter
	    i++
        vboxes.add_gradient_button {        
          text = shorthand_format (format('Hangar #%d',i)),
          gradient_color = 'blue',  
          icon = 'spaceship',   

          force_rw=280,
          force_rx=60,

          invalid=catch | (not empire:known 'Multirole Fighters' or tostring(w.parent_type)=="Interceptor" or tostring(w.parent_type)=="Bomber"),
		  
		  tooltip_text = format('Switch between Strike Fighters, EMP Bombers or Leech Bombers for Hangar #%d.',i),
		   
          on_click = function()

			    --if tostring(w.parent_type)=="Interceptor" then w.parent_type="Bomber"
				--elseif tostring(w.parent_type)=="Bomber" then w.parent_type="EMP Bomber"
				--else
				if tostring(w.parent_type)=="EMP Bomber" then w.parent_type="Leech Bomber"
				elseif tostring(w.parent_type)=="Leech Bomber" then w.parent_type="Strike Fighter"
				--elseif tostring(w.parent_type)=="Strike Fighter" then w.parent_type="Interceptor"
				elseif tostring(w.parent_type)=="Strike Fighter" then w.parent_type="EMP Bomber"
				end

          end,
        }
		vboxes.add_vspace(5)
	  end
	end
	if i>0
      --vboxes.add_vspace(5)
      if (not empire:known 'Multirole Fighters') then
	    vboxes.add_text_vbox | desc_format [[<b>Multirole Fighters</b> technology needs to be researched before role specific fighters could be assigned.]]
	   else vboxes.add_text_vbox | desc_format [[Assign role specific fighters to each <i>Hangar</i>.]] end
	  vboxes.add_vspace(28)
	end
  end
  
  --!! SCRAP option
  local function add_scrap_option(vboxes)
    local ship = object
    local scrap_value, can_scrap, can_scuttle, scrap_metal in (ship.carrying_ship or ship)
    local mercenary_empire in ship

    if mercenary_empire

      vboxes.add_gradient_button {        
        text = shorthand_format ('Dismiss Mercenary'),
        gradient_color = 'yellow',  
        icon = 'spaceship',   

        force_rw=280,
        force_rx=60,

        invalid=catch | not can_scuttle,

        tooltip_text = 'Dismissed mercenaries can be re-hired via the mercenary exchange; though the mercenaries may take the opportunity to upgrade their weapon systems while off-duty.',
        on_click = function()
          order.dismiss_mercenary(ship)
          close_midscreen_pane()
        end,
      }
      vboxes.add_vspace(5)
      vboxes.add_text_vbox | desc_format [[
          Dismiss these mercenaries from your service.  They will return to their
          parent mercenary company.]] 

    elseif can_scrap

      vboxes.add_gradient_button {        
        text = shorthand_format ('Scrap <CAP_SHIP_STATION>'),
        gradient_color = 'yellow',  
        icon = 'recycle',   

        force_rw=280,
        force_rx=60,

        invalid = catch | (ship.carrying_ship or ship).cant_scrap,

        tooltip_text = SCOPE_fun(report=r, ..context_subs,|) function()
           return shorthand_format | 'Dissemble this <SHIP_STATION> for resources.  Scrapping <SHIPS_STATIONS> is only possible while the vessel is in a system that we control.',
        end,

        on_click = function()
          order.scrap_ship(ship.carrying_ship or ship)
          Sounds.SCRAP_SCUTTLE_SHIP()
          close_midscreen_pane()
        end,
      }
      vboxes.add_vspace(5)
      vboxes.add_text_vbox | desc_format [[
          Disassemble this <SHIP_STATION> for resources.  Yields
          <SCRAP_COINS><COIN> and <SCRAP_METAL><METAL>.
       ]] 

    else

      vboxes.add_gradient_button {        
        text = shorthand_format ('Scuttle Ship'),
        gradient_color = 'red',  
        icon = 'explosion',   

        force_rw=280,
        force_rx=60,

        invalid=catch | not can_scuttle,

        tooltip_text = 'Any ship under your control can be scuttled, provided that it is not engaged in active combat.',
        on_click = function()
          order.scrap_ship(	ship.carrying_ship or ship)
          Sounds.SCRAP_SCUTTLE_SHIP()
          close_midscreen_pane()
        end,
      }
      vboxes.add_vspace(5)
      vboxes.add_text_vbox | desc_format [[
          Trigger <OBJECT_NAME>'s self destruct sequence. 
      ]] 

    end

  end

  --!! SCRAP option
  local function add_reverse_engineer_option(vboxes)
    local ship = object

    local src_empire,empire,cant_scrap in ship

    local techs,one_odds = ship:recoverable_tech_info()

    vboxes.add_gradient_button {        
      text = shorthand_format ('Reverse Engineer'),
      gradient_color = 'blue',  
      icon = 'reverse_engineer',   

      force_rw=280,
      force_rx=60,

      invalid = catch | (cant_scrap or (one_odds==0) ),

      tooltip_text = SCOPE_fun(report=r, ..context_subs,|) function()
          return shorthand_format | 'Send this <SHIP_STATION> to our science teams for reverse engineering.  Reverse engineering is only possible while the vessel is in a system that we control.',
      end,

      on_click = function()
        local r = order.reverse_engineer_single_ship(ship)
        Sounds.SCRAP_SCUTTLE_SHIP()
        close_midscreen_pane()
        report_hint(r)
      end,
    }
    vboxes.add_vspace(5)
    local coda

    if not next(techs) 
    
      coda =  [[
        <bi>This ship contains no technology that can be usefully reverse
        engineered</bi>. ]] 
     
    else
      coda = format( [[ We have a <b>%d%%</b> chance of recovering technology from this ship.]],100*one_odds )
    end 

    vboxes.add_text_vbox | desc_format | [[
        Disassemble this <SHIP_STATION> in an attempt to reverse
        engineer its technologies. ]]..coda

  end

  function rebuild_draw_desc_pane()
    --print('rebuilding desc_pane!',object.name)
    local x,y,w,h
    local _TRACE_INFO = object.name

    if show_colony_pane()
      x,y,w,h=expanded_desc_rect()
    else
      x,y,w,h=biggest_desc_rect()
    end

    --print('clearing desc context')
    desc_text_context.clear()
    current_desc_rect=catch(x,y,w,h)
    local vboxes = framed_scrolling_vboxes {
       rect= catch | box_grow(-12,-8,x+2,y-5,w-5,h-5),
       text_context=desc_text_context,
    }

    desc_scroll_area=vboxes.scroll_area

    local scroll_position = NavFrame.make_scroll_position(
      vboxes.scroll_area,
      x,y,w,h
    )

    local function set_generic_desc_text(key)
      vboxes.add_vspace(-8)


      local info = PLANET_INFO[key]

      if info
        return info(vboxes,SCOPE.planet)
      end

      vboxes.add_text_vbox | format("<h1>%s</h1>",key)


      vboxes.add_text_vbox | shorthand_format | optional_dev_info (
        LONG_INFO[key] or INFO[key] or format('missing info for %q',tostring | key)) 
    end

    function set_ship_system_desc_text(i)
      --vboxes.add_vspace(-8)

      --vboxes.add_text_vbox | format("<h1>%s</h1>",key)

      vboxes.add_text_vbox | systems_text[i]
    end

    function rebuild_desc_vboxes()
      vboxes.clear()
      local desc_key=link_history.current()
      if (desc_key==object) or (desc_key==object.carrying_ship)
				--print('set object')
        return set_base_ship_desc_text()
      end

      if type(desc_key)=='number'
				--print('set number')
        return set_ship_system_desc_text(desc_key)
        -- systems_text![desc_key]
      end

      --[[
  if PartInfo[key]
    return get_system_desc(key,empire)
  end
  --]]
			--print('set generic')
      return set_generic_desc_text(desc_key)

    end


    function set_base_ship_desc_text()
      vboxes.clear()
			--print('rebuild base',stack_trace(6))
      -- the header has funny spacing..

      if object.is_planet
        vboxes.add_vspace(-8)
        return vboxes.add_text_vbox | get_planet_desc(object.planet)
      end

--      vboxes.add_text_vbox | shorthand_format "<h1><OBJECT_NAME></h1>"


      --[[
      if object._parent==all_ships
        vboxes.add_text_vbox | shorthand_format "  <b>Hull:</b> <SHIP_CONFIG_NAME>"
        vboxes.add_text_vbox | shorthand_format "  <b>Design:</b> <OBJECT_DESIGN_NAME>"
      end
      vboxes.add_vspace()

      --]]

  --    vboxes.add_vspace()

      if object._parent==all_ships
        local hull_desc_key in (object.carrying_ship or object).config_table

        vboxes.add_text_vbox |
         shorthand_format( '<b><SHIP_CONFIG_NAME></b>: ') .. tostring ( 
          (optional_dev_info | drawers.HullDescriptions[hull_desc_key] or format('missing: %q',hull_desc_key)) )
      
        if object.mercenary_empire
          vboxes.add_vspace()
          vboxes.add_text_vbox |
            '<b>Mercenary</b>: ' .. 'This ship is a mercenary unit. ' .. optional_dev_info | LONG_INFO.Mercenary
        end

				if object.carrying_ship
					vboxes.add_vspace()
					vboxes.add_text_vbox | desc_format [=[
						The station loaded in this transport is currently disassembled, and
						any systems cannot be used in combat.
					]=]
				end

      end

      if is_player_ship() and ( not show_embark_info() ) and ( (object.pop_space or 0) > 0)
          add_alien_transport_info(vboxes)
          --vboxes.add_vspace()
      end

      if is_player_ship()
        
        vboxes.add_vspace(28)

        if object.inactive
          add_inactive_info(vboxes)
          vboxes.add_vspace(28) 
        end

        if show_trade_pane()
          add_trade_option(vboxes)
          vboxes.add_vspace(28) 
        end

        if object.can_colonize_any
          --vboxes.add_vspace()
          --vboxes.add_text_vbox('<b>Colonize:</b>')

          add_colonize_option(vboxes)
          vboxes.add_vspace(28)        
        end

        if show_embark_info()
          --vboxes.add_vspace()
          --vboxes.add_text_vbox('<b>Population Transport:</b>')

          add_population_transport_options(vboxes)
          vboxes.add_vspace(28)
        end

				if object.hab_space
					add_hab_pop_options(vboxes)
	        vboxes.add_vspace(28)
				end

				if object.drawer_table?.mobile_station 
					if not object.is_fixed
						add_enter_orbit_option(vboxes)
					else
						add_leave_orbit_option(vboxes)
					end

					vboxes.add_vspace(28)       
				end

        if not  (object.trade_eta or object.transport_dest or object.mercenary_empire)
          --vboxes.add_text_vbox('<b>Refit:</b>')

          add_refit_option(vboxes)
          vboxes.add_vspace(28) 
        end

		add_fighter_role_option(vboxes)
		--vboxes.add_vspace(28)

        add_scrap_option(vboxes)
        vboxes.add_vspace(28) 

        if (object.src_empire~=object.empire) and (find_ships_fleet(object))
          add_reverse_engineer_option(vboxes)
          vboxes.add_vspace(28) 
        end

      elseif object.pop_space
        add_alien_transport_info(vboxes)

      end


    end

		set_desc_text(link_history.current())

    function draw_desc_pane()
      NavFrame.frame.draw_bk(x,y,w,h)
      vboxes.clipped_draw()
      NavFrame.draw_frame(x,y,w,h)


      NavFrame.draw_arrows( link_history, prev_link, next_link, x,y,w,h )

      scroll_position.draw()
    end

  end

 





end

link_history = link_history or new_link_history()

local function raw_set_desc_text(key)
  link_history.follow_link(key)
  rebuild_desc_vboxes?()
end


function set_desc_text(key)
  local planet


  if object.recorded?._parent==all_planets
    planet=object.recorded?
  elseif object._recorded==all_planets
    planet=object
  end

  print(..key,..object,..planet)

  return SCOPE_call(..object,..planet,..context_subs, empire=gui_player(),
    raw_set_desc_text,key)

end


function after_weak_clears.ship_midscreen_pane()
  draw_desc_pane=nil
  if _undefined(object) object=nil return end
  
  if object
    name_edit.set_text( (object.carrying_ship or object).name)
  end
end

function on_open(nobject)
  
--  print('on open',nobject.name,object?.name,object~=nobject)


	if nobject.carried_ship
		object = nobject.carried_ship
	  name_edit.set_text(nobject.name)
	else
	  object=nobject
	  name_edit.set_text(object.name)
	end


  draw_desc_pane=nil
  draw_colony_pane=nil

  link_history.clear()
  link_history.follow_link | object



end

function prev_link()
  set_desc_text( link_history.get_prev() )
end

function next_link()
  set_desc_text( link_history.get_next() )
end

local draw_bar_overlay do

  local color_set =  { 
    oranges = color_table {
      progress = 'f8971d',
      next_progress = '8f5909',
      empty = '28231c',
    },

    reds = color_table {
      progress = 'cf111a',
      next_progress = '741c10',
      empty = '521b1e',
    },

  }

  local backing = fade_color_param('040912',59)

  local draw_bar = restore_color | function(colors,text,bar0,bar1)
    local x,y,w,h =profile_inset_rect()

    local bx,by = round_all( x+38,y+97 )
    local bw,bh = 170,9 

    set_frame_color4 | backing()
    glBox(bx-8,by-7,186,38)
    local c = color_set[colors]

    set_frame_color4 | c.empty()
    glBox|round_rect(bx,by,bw,bh)

    if bar1
      set_frame_color4 | c.next_progress()
      glBox|round_rect(bx,by,bw*bar1,bh)
    end

    set_frame_color4 | c.progress()
    glBox|round_rect(bx,by,bw*bar0,bh)

    local word0 = tooltip_text_context.lazy_word_render('vera14', 
      text)
    set_frame_color4 (1,1,1,1)
    local tx,ty=-1,bh+5
    word0.draw(bx+tx,by+ty)

    local word1 = tooltip_text_context.lazy_word_render('vera14', 
      format('%d%%',round | 100*bar0) )

    word1.draw_br(bx+tx+bw+2,by+ty)
  end

  draw_bar_overlay = function()
    local displayed_hp_percent,refit_progress in object

    if refit_progress
      return draw_bar('oranges', 'Refit Progress', object:expected_refit_progress() )
    elseif displayed_hp_percent
      return draw_bar('reds', 'Hull Integrity', object:expected_hp_percent())
    end

  end
end

function draw_profile_pane()

  HeavyFrame.draw_bk | ship_profile_rect()


	local object = object.carrying_ship or object
	local drawer_t = object.drawer_table

  insert( element | ship_profile_rect(),
    desc_text=object)


  local rx,ry,rw,rh=ship_clip_rect()

  local x,y,w,h =profile_inset_rect()
  x,y-=rx,ry
  local tx,ty,s,degree= (object.drawer_table or drawer_t)!.rect_fit(object, x,y,w,h, target=target )

  clipped_box(rx,ry,rw,rh,
    gui.immediate_request, object, drawer_t, tx,ty,s,degree)


  draw_bar_overlay()

  if (object.empire~=gui_player()) or ( object._parent~=all_ships._ref )
    name_edit.draw 'no_element'
  else
    name_edit.draw()
  end

  HeavyFrame.draw_frame | ship_profile_rect()



  insert(profile_close_element(),
    on_click=close_midscreen_pane,
    --on_hover=hand_cursor
  )



--  glBox(ship_clip_rect())

end


function esc_handler()

  if name_edit.is_active()
    name_edit.cancel()
    Sounds.PANE_CLOSE()
    return
  else
    Sounds.PANE_CLOSE()
    close_midscreen_pane()
  end


end

name_edit = EditableText {
  _ENV=_ELEMENT_ENV,
  --font_key = 'secret60',
  font_key='orig42',
  max_text_len=22, 
  format_safe=true,
  shorthand_safe=true,

  pick_rect= function()
    return title_pick()
  end,

  text_anchor = function(tw,th)
    local rx,ry,rw,rh = title_pick()
    return round_all( rx+(rw-tw)*.5,ry+12 )
  end,

  on_enter = function(text)


    if not text
      errorf("can't set name to %q",tostring(text))
    end

    -- a little cleverness to hide repeated set-name orders
    -- applied to the same planet.
    local last_order,empire,args = last_order_info()
    if last_order == 'set_ship_name'
      local ship_name=args:match( "..(.*)%._ref")
      if ship_name == recorded_name(object)
        undo_order()
      end
    end

    order.set_ship_name(object.carrying_ship or object,text)
    draw_desc_pane=nil

    --reset_planet_desc_text(selected_planet)
    --]]
  --	set_design_name(get_design_name())
  end

}





if object
  name_edit.set_text( (object.carrying_object or object).name)
end

function is_player_ship()
  return (object._parent==all_ships._ref) and (object.empire==gui_player())
end

function show_embark_info()
  return is_player_ship() and object.pop_space and (not object.trade_eta)
end

function include_stats_rect()
  return object.structure
end


function draw_middile_panes()
  --glBox | desc_rect()

  --NavFrame.draw_bk | desc_rect()
  
  --memconsole(object.defenseless,v2s|object)

  if include_stats_rect()
    if not draw_status_pane
      rebuild_status_pane()
    end
    draw_status_pane()
  end


  if show_colony_pane()
    if not draw_colony_pane
      rebuild_draw_colony_pane()
    end
    draw_colony_pane()
  end



  if not draw_desc_pane
    rebuild_draw_desc_pane()
  end
  draw_desc_pane()

  --[[

    NavFrame.draw_frame | desc_rect()

  elseif  include_stats_rect()
    NavFrame.draw_frame | expanded_desc_rect()

  else
    NavFrame.draw_frame | biggest_desc_rect()
  end
  --]]

end

function show_short_systems()
  return show_trade_pane() or show_colony_pane()
end

function show_trade_pane()
  return object.cargo_space
end

function show_colony_pane()
  return ( object._parent==all_planets ) or (object.recorded?._parent == all_planets)
end

function show_system_pane()
  if _undefined(object) object=nil return end
  return object?.structure
end

local raw_draw =  gl_matrix_fun | function()

  TopBarFrame.draw_simple_bar | top_bar.bar_rect()
  insert( top_bar.next_year_word(),
    'on_click', end_year_click,
    'on_hover', hand_cursor,
  )

  if not show_system_pane()
    glTranslate2D(200,0)
    --glBox | half_complete_rect()
    element | half_complete_rect()
  else
    element | midscreen_rect_plus()
  end


  draw_profile_pane()
  draw_middile_panes()

  SCOPE_call(systems_skin = ship_systems_frame, 
    ..subbox,
    draw_systems)

    --[[
  if show_trade_pane()
    if not draw_trade_pane
      rebuild_draw_trade_pane()
    end
    draw_trade_pane()
  end
  --]]


  --if show_trade_pane() or show_system_pane()
  --[[
  insert(rightside_close_element(),
    on_click=close_midscreen_pane,
  )--]]
end

function context_subs(tag)
  if tag=='REFIT_DESIGN_NAME'
    return get_current_refit_option?()?.design?.design_name
  end
  if tag=='OBJECT_DESIGN_NAME'
    return object.source_design.design_name
  end
  if tag=='REFIT_COST'
    local coin_cost, hammer_cost,metal_cost in get_current_refit_option?()?
    if coin_cost
      return shorthand_format | format( '%d<COIN> and %d<METAL>',coin_cost,metal_cost)
    end
  end
  if tag=='SHIP_CONFIG_NAME'
    return (object.carrying_ship or object).config_name
  end

  if tag=='OBJECT_NAME'
    return (object.carrying_ship or object).name
  end

  if tag=='SCRAP_METAL'
    return tostring | object.scrap_metal
  end
  if tag=='SCRAP_COINS'
    return tostring | object.scrap_value
  end

  if tag=='SHIP_STATION'
    return object.orbiting_planet and 'station' or 'ship'
  end
  if tag=='CAP_SHIP_STATION'
    return object.orbiting_planet and 'Station' or 'Ship'
  end

  if tag=='SHIPS_STATIONS'
    return object.orbiting_planet and 'stations' or 'ships'
  end

end

local function bold_info_header(p)
	return format("<b>%s</b>: ",p)
end

draw = restore_color | function()

  set_frame_color4(1,1,1, 1)



  if _undefined(object) or (not object) or object.dead or (not drawer_t)
    if midscreen_pane == _ENV
      close_midscreen_pane()
    end
    return
  end

  local planet

  if object.recorded?._parent==all_planets
    planet=object.recorded?
  elseif object._recorded==all_planets
    planet=object
  end

  SCOPE_call(..object,..planet,..context_subs, empire=gui_player(),
    info_header_fun=bold_info_header,
    raw_draw)

  --end

--  glBox | system_list_rect()

--glBox | complete_rect()
  --TabLongFrame.draw_frame | system_list_rect()
end

function _ELEMENT_ENV.open_ship_status_pane(...)
  open_midscreen_pane(ship_status_pane,...)
end

end